using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_HotelPuntoVenta._0_Modelos;
using Exferia_HotelPuntoVenta.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_HotelPuntoVenta._3_Vistas.Listados
{
    public class ABS_Listado_HPV_Tarifas_EnMantenimiento : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_HPV_Tarifas_EnMantenimiento()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //orden
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.orden), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.orden), "Orden", G_ENUM_TIPOSDATOS.INT, false, 90, true, false, true, false, "", null, false));

            //fechaDesde
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.fechaDesde), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.fechaDesde), "Fecha desde", G_ENUM_TIPOSDATOS.DATETIME, false, 150, true, false, true, false, "", null, true));

            //fechaHasta
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.fechaHasta), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.fechaHasta), "Fecha hasta", G_ENUM_TIPOSDATOS.DATETIME, false, 150, true, false, true, false, "", null, true));

            //Clientes/AgrupacionClientes
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.Cliente_AgrupacionCliente), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.Cliente_AgrupacionCliente), "Clientes/Agrupación de clientes", G_ENUM_TIPOSDATOS.TEXT, false, 250, false, true, true, false, "", null, false));

            //Cliente
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_CLIENTE = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.idCliente), nameof(HPV_Clientes), nameof(HPV_Clientes.id), nameof(HPV_Clientes.codigo), nameof(HPV_Clientes.razonSocial), nameof(HPV_Clientes.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.Cliente_Codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.Cliente_Codigo), "Cliente", G_ENUM_TIPOSDATOS.RELACIONADA_CONLISTADOINTERNO, true, 0, true, true, false, true, "", null, true, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_CLIENTE, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.AgrupacionCliente_IdsClientesAgrupados)));

            //Agrupacion de Cliente
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_AGRUPACIONCLIENTE = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.idAgrupacionClienteLinea), nameof(HPV_AgrupacionesClientesLineas), nameof(HPV_AgrupacionesClientesLineas.id), nameof(HPV_AgrupacionesClientesLineas.codigo), nameof(HPV_AgrupacionesClientesLineas.descripcion), nameof(HPV_AgrupacionesClientesLineas.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.AgrupacionCliente_Codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.AgrupacionCliente_Codigo), "Agrupación Cliente", G_ENUM_TIPOSDATOS.RELACIONADA, true, 0, true, true, false, true, "", null, true, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_AGRUPACIONCLIENTE));

            //PLV/AgrupacionPLV
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.PLV_AgrupacionPLV), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.PLV_AgrupacionPLV), "PLV/Agrupación de PLV", G_ENUM_TIPOSDATOS.TEXT, false, 250, false, true, true, false, "", null, false));

            //PLV
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_PLV = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.idPLV), nameof(HPV_PLV), nameof(HPV_PLV.id), nameof(HPV_PLV.codigo), nameof(HPV_PLV.descripcion), nameof(HPV_PLV.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.PLV_Codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.PLV_Codigo), "PLV", G_ENUM_TIPOSDATOS.RELACIONADA_CONLISTADOINTERNO, true, 0, true, true, false, true, "", null, true, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_PLV, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.AgrupacionPLV_IdsPLVAgrupados)));

            //Agrupacion de PLV
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_AGRUPACIONPLV = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.idAgrupacionPLVLinea), nameof(HPV_AgrupacionesPLVLineas), nameof(HPV_AgrupacionesPLVLineas.id), nameof(HPV_AgrupacionesPLVLineas.codigo), nameof(HPV_AgrupacionesPLVLineas.descripcion), nameof(HPV_AgrupacionesPLVLineas.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.AgrupacionPLV_Codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.AgrupacionPLV_Codigo), "Agrupación PLV", G_ENUM_TIPOSDATOS.RELACIONADA, true, 0, true, true, false, true, "", null, true, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_AGRUPACIONPLV));

            //precio
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.precio), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.precio), "Precio", G_ENUM_TIPOSDATOS.DECIMAL, false, 150, true, false, true, false, "", null, true));

            //descuento
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Tarifas_Listado_Modelo.descuento), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Tarifas_Listado_Modelo.descuento), "Descuento", G_ENUM_TIPOSDATOS.DECIMAL, false, 150, true, false, true, false, "", null, true));

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_HPV_TARIFAS);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_HPV_TARIFAS + "EnMantenimiento";
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_HPV_Tarifas_Listado_Modelo.orden);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
